<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
 */

defined('_JEXEC') or die;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;

require_once __DIR__ . '/script.install.helper.php';

class PlgContentSocial2sInstallerScript extends PlgContentSocial2sInstallerScriptHelper
{
    public $name = 'JT | Social2s';
    public $alias = 'social2s';
    public $extension_type = 'plugin';
    public $plugin_folder = 'content';
    public $minJtfwVersion = '4.0.10';

    public function onBeforeInstall()
    {

        if (!$this->jtfwInstalled()) {
            $app = Factory::getApplication();
            $app->enqueueMessage(Text::_('JT framework required. Please, <a target="_blank" href="https://users.jtotal.org/SOFT/framework/JTframework/jtframework_v4_current.zip">download at jtotal.org</a> and install it before.'), 'error');
            return false;
        }else{
            //check old framework update
		    $this->checkOldFrameworkUpdate('https://users.jtotal.org/SOFT/UPDATES/PLUGINS/social2s/social2sv4-update.xml');
        }


    }
}
