<?php
/**
 * @Copyright
 * @package     Field - backend
 * @author      anton {@link https://jtotal.org}
 * @version     Joomla! 3.0 & 4.0 - 4.0.124
 * @date        Created on 09-09-2018
 * @link        Project Site {@link https://jtotal.org}
 *
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Jtotal\Plugin\Content\Social2s\Fields;

use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;

// phpcs:disable PSR1.Files.SideEffects
\defined('JPATH_PLATFORM') or die;
// phpcs:enable PSR1.Files.SideEffects

class S2sBackendField extends FormField
{
    protected $type = 'S2sBackend';

    protected function getLabel()
    {
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {

        $social2s_minify_debug = $this->form->getValue('params')->social2s_minify_debug;
        $wa = Factory::getDocument()->getWebAssetManager();

        $wa->getRegistry()->addRegistryFile('media/plg_content_social2s/joomla.asset.json');
 
        $wa->UseStyle('plg_content_social2s.backend');
        $wa->UseScript('plg_content_social2s.backend');


        //$wa->useScript('plg_content_social2s.backend');
        //$wa->registerAndUseStyle('social2s_backend_css', 'plg_content_social2s/s2sv5_backend.min.css');
        
        /*
        $wa->registerAndUseScript(
            'social2s_backend_js',
            'plg_content_social2s/s2sv5_backend.js',
            ['version' => 'auto', 'relative' => true],
            ['defer' => true],
            ['jquery']
        );
        */
    }
}
