<?php
/**
 * @Copyright
 * @package     Field - S2s Order
 * @author      anton {@link http://www.dibuxo.com}
 * @version     Joomla! 3.x - 1.0.24
 * @date        Created on 09-09-2013
 * @link        Project Site {@link http://dibuxo.com}
 *
 * @license GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Jtotal\Plugin\Content\Social2s\Fields;

use Joomla\CMS\Form\FormField;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\Registry\Registry;

// phpcs:disable PSR1.Files.SideEffects
\defined('JPATH_PLATFORM') or die;
// phpcs:enable PSR1.Files.SideEffects

class S2sbs1stField extends FormField
{
    protected $type = 'S2sbs1st';

    protected function getLabel()
    {
        return '';
    }

    protected function getInput()
    {
        $field_set = $this->form->getFieldset();

        $params = new Registry($this->form->getValue('params'));
        $s2s_active_accordeons = $params->get('s2s_active_accordeons', '');

        //var_dump(json_decode($s2s_active_accordeons));

        $id = ($this->element['id'] === null) ? '' : strtolower($this->element['id']);
        $mode = ($this->element['mode'] === null) ? '' : strtolower($this->element['mode']);

        $initial = ($this->element['initial'] === null) ? '' : strtolower($this->element['initial']);
        $label = ($this->element['label'] === null) ? '' : strtolower($this->element['label']);
        $slide = ($this->element['slide'] === null) ? '' : strtolower($this->element['slide']);
        $acordeon = ($this->element['acordeon'] === null) ? '' : strtolower($this->element['acordeon']);

        $active_default = ($this->element['active'] === null) ? '' : strtolower($this->element['active']);
        //$active = ($this->value == NULL) ? $active : $this->value;

        if ($initial == 'true') {
            if (is_array(json_decode($s2s_active_accordeons))) {
                $active = (in_array($active_default, json_decode($s2s_active_accordeons))) ? $active_default : '';
            } else {
                $active = '';
            }

            $accStart = HTMLHelper::_('bootstrap.startAccordion', $acordeon, array('active' => $active));
            return $accStart;
        } elseif ($initial == 'slide') {
            $slider = HTMLHelper::_('bootstrap.addSlide', $acordeon, Text::_($label), $slide);
            return $slider;
        } elseif ($initial == 'end') {
            $end = HTMLHelper::_('bootstrap.endSlide');
            return $end;
        } elseif ($initial == 'superend') {
            $superend = HTMLHelper::_('bootstrap.endAccordion');
            return $superend;
        }
    }
}
