<?php

/**
 * @package     Joomla.Plugin
 * @subpackage  Content.social2s
 *
 * @copyright   Copyright (C) 2005 - 2022 jtotal.org All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

namespace Jtotal\Plugin\Content\Social2s\Helper;

use Joomla\CMS\Environment\Browser;
use Joomla\CMS\Factory;
use Joomla\CMS\Filter\OutputFilter;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Version;
use Joomla\Component\Content\Site\Helper\RouteHelper;
use PlgContentSocial2s;

defined('_JEXEC') or die;

class S2sTmpl
{

    public static $s2s_obj;

    //style
    public static $s2s_styles;

    //scripts
    public static $s2s_noscripts;

    //buttons
    public static $s2s_buttons;

    //check loaded scripts
    public static $s2s_loaded_scripts;

    public function __construct()
    {
        self::$s2s_obj = PlgContentSocial2s::$s2s_obj;
    }

    public static function init($s2s_obj, $article)
    {
        self::$s2s_obj = $s2s_obj;

        // prepare DATA
        self::prepareArticle($article);

        //MOBILE
        self::getMobile();

        //SCRIPTS
        self::getScripts();

        //LANGUAGE
        self::getLanguage();

        //STYLES
        PlgContentSocial2s::$s2s_obj->styles = self::getStyles();

        //Scripts
        $tmpl = self::loadStyle();
        self::$s2s_noscripts = $tmpl;

 
        //BUTTONS
        self::$s2s_buttons = self::getButtons();
        


        //LINKS
        //self::getLinks();

        //VARIABLES
        self::getVariables();

        //COOKIE BUTTON
        PlgContentSocial2s::$s2s_obj->cookie_button = self::getCookieButton();

        //CLASSES
        self::$s2s_obj->supraclasses = self::getSupraClasses();

        /************************** */
        /*LOGIC IN TMPL*/
        return;
        return;
        return;
        return;
        return;
        return;

        //SOCIAL
        $social = self::getSocial();

        //HTML
        //$html = self::getHtml($social);
        $html = '';

        return $social;

        return $html . $tmpl;
    }

    /**
     * [prepareArticle description]
     * @param  [type] $article [description]
     * @return [type]          [description]
     */
    public static function prepareArticle($article)
    {

        if (isset($article->catid)) {
            self::$s2s_obj->catid = $article->catid;
        }

        if (isset($article->id)) {
            self::$s2s_obj->id = $article->id;
        }

        if (isset($article->alias)) {
            self::$s2s_obj->alias = OutputFilter::stringURLSafe($article->title);
        }

        if (isset($article->title)) {
            self::$s2s_obj->title = $article->title;
        }

        if (isset($article->slug)) {
            self::$s2s_obj->slug = $article->slug;
        }

        $context = self::$s2s_obj->context;
        $uri = uri::getInstance();

        //    /////////////////////////////////
        //    //////    DEFAULT DATA    ///////
        //    /////////////////////////////////

        $description = '';
        $app = Factory::getApplication();
        $metadescription = $app->get('MetaDesc');
        $image = '';
        $jinput = $app->input;

        $S2sImages = new S2sImages;

        /////////////////////////////////
        //////      VIRTUEMART    ///////
        /////////////////////////////////
        if ($context == 'com_virtuemart.productdetails') {
            $vm_link = str_replace(URI::base(), "", $uri->toString());
            $link = Route::_($vm_link);
            $full_link = 'http' . (isset($_SERVER['HTTPS']) ? 's' : '') . '://' . "{$_SERVER['HTTP_HOST']}/{$_SERVER['REQUEST_URI']}";

            $description = self::_descriptionFormatted($article->product_desc);

            $article->title = $article->product_name;

            //IMAGES
            $images = $S2sImages::getImagesVirtuemart($article);

            /////////////////////////////////
            //////       JEVENTS      ///////
            /////////////////////////////////
        } elseif ($context == 'com_jevents' || $context == 'com_jevents.') {
            $option = $jinput->get('option');
            $task = $jinput->get('task');
            $evid = $jinput->get('evid');
            $Itemid = $jinput->get('Itemid');
            $year = $jinput->get('year');
            $month = $jinput->get('month');
            $day = $jinput->get('day');
            $title = $jinput->get('title');
            $uid = $jinput->get('uid');

            $url = 'index.php?option=com_jevents&task=' . $task . '&evid=' . $article->_ev_id . '&Itemid=' . $Itemid . '&year=' . $year . '&month=' . $month . '&day=' . $day . '&title=' . $title . '&uid=' . $uid;

            $url = Uri::getInstance();

            //$full_link = JURI::base() . substr(JRoute::_($url, false), strlen(JURI::base(true)) + 1);
            $full_link = $url;

            $description = self::_descriptionFormatted($article->_description);

            //$link = substr(JRoute::_('index.php?option=com_jevents&task=icalrepeat.detail&evid='.$article->_ev_id, false), strlen(JURI::base(true)) + 1);

            //$link =  \Joomla\CMS\Router\Route::_(substr(JRoute::_($url, false), strlen(JURI::base(true)) + 1), $xhtml = false, $ssl = null);
            //$link =  substr(JRoute::_($url, false), strlen(JURI::base(true)) + 1);
            $link = substr(Route::_($url, false), strlen(Uri::base()));

            //$link =  $url;

            $images = $S2sImages::getImagesJevents($article);
        } else {
            //API
            if (isset($article->link)) {
                $link = Route::_($article->link);
                $full_link = $link;
            } else {
                //LINKS
                $link = Route::_(RouteHelper::getArticleRoute(self::$s2s_obj->slug, self::$s2s_obj->catid));
                $full_link = URI::base() . substr(Route::_(RouteHelper::getArticleRoute(self::$s2s_obj->slug, self::$s2s_obj->catid)), strlen(Uri::base(true)) + 1);
            }

            //DESCRIPTION
            if (isset($article->introtext)) {
                $description = self::_descriptionFormatted($article->introtext);
            }

            //METADESCRIPTION
            if (isset($article->metadesc)) {
                if ($article->metadesc != '') {
                    $metadescription = $article->metadesc;
                }
            }

            //IMAGES
            $images = $S2sImages::getImagesArticle($article);
        }

        self::$s2s_obj->title = $article->title;
        self::$s2s_obj->safetitle = json_encode($article->title);
        self::$s2s_obj->description = $description;
        self::$s2s_obj->metadescription = $metadescription;

        self::$s2s_obj->link = $link;
        self::$s2s_obj->full_link = $full_link;

        self::$s2s_obj->images = $images;

        $uri = uri::getInstance();
        self::$s2s_obj->url = $uri;
        self::$s2s_obj->absolute_url = $uri->toString();

        PlgContentSocial2s::updateS2sDebug('Title', self::$s2s_obj->title, 'info', 'file-text');
        PlgContentSocial2s::updateS2sDebug('Description', self::$s2s_obj->description, 'info', 'file-text');
        PlgContentSocial2s::updateS2sDebug('Link', $link, 'info', 'link');
        PlgContentSocial2s::updateS2sDebug('Full_link', $full_link, 'info', 'link');

        //update main s2s_object
        PlgContentSocial2s::$s2s_obj = self::$s2s_obj;
    }

    /**
     * [_descriptionFormatted format descriptions]
     * @param  string $text [description]
     * @return [type]       [html]
     */

    private static function _descriptionFormatted($text)
    {

        $regex = '#{(.*)}#iU';
        $regex2 = '#{/(.*)}#iU';
        $output = "";
        $first_plugin = preg_replace($regex, $output, $text);
        $second_plugin = preg_replace($regex2, $output, $first_plugin);

        $description = implode(' ', array_slice(explode(' ', strip_tags($second_plugin, '<br>')), 0, 70));

        $description = str_replace(array("\r", "\n"), '', $description);

        $description = html_entity_decode($description, ENT_COMPAT, 'UTF-8');

        $description = str_replace('<br />', '', $description);

        return $description;
    }

    /**
     * [MOBILE checker]
     * @return none
     */
    public static function getMobile()
    {

        $jmobile_fw = Browser::getInstance();
        self::$s2s_obj->jmobile = $jmobile_fw->isMobile();

        $s2s_mobile = self::$s2s_obj->jmobile;

        $doc = Factory::getDocument();
        $doc->addScriptDeclaration("var s2s_mobile = '{$s2s_mobile}';");
    }

    /**
     * [SCRIPTS loader]
     * @return none
     */
    public static function getScripts()
    {
        $jversion = new Version();
        $document = Factory::getDocument();
        $plugin_path = self::$s2s_obj->plugin_path;
        $images_path = self::$s2s_obj->images_path;
        $media_path = self::$s2s_obj->media_path;

        $params = self::$s2s_obj->params;

        /** @var Joomla\CMS\WebAsset\WebAssetManager $wa */
        $wa = Factory::getDocument()->getWebAssetManager();
        $wa->getRegistry()->addExtensionRegistryFile('plg_content_social2s');

        $wa->useScript('social2s.frontend');

        //force reload
        if ($params->get('s2s_debug', 0) == 1) {
            $randnumber = md5(rand(1, 100));
            $wa->registerAndUseScript(
                'social2s.frontend',
                'plg_content_social2s/social2s.js',
                ['version' => $randnumber, 'relative' => true],
                ['defer' => true],
                ['jquery']
            );
        }
    }

    /**
     * [LANGUAGE]
     * @return none
     */
    public static function getLanguage()
    {
        $app = Factory::getApplication();
        $params = self::$s2s_obj->params;

        $idioma = $params->get('s2s_language', '0');
        $idioma_joomla = Factory::getLanguage()->getTag();
        // Twitter and Gplus
        if ($idioma != '0') {
            $idioma_twitter = substr($idioma, 0, 2);
        } else {
            $idioma_twitter = substr(str_replace('-', '_', $app->getLanguage()->getTag()), 0, 2);
            $idioma = str_replace('-', '_', $app->getLanguage()->getTag());
        }

        $lang = $app->getLanguage();
        $lang_direction = $lang->get('rtl');

        if ($lang_direction == 0) {
            $lang_direction = 'lang_directon_right';
        } else {
            $lang_direction = 'lang_directon_left';
        }
        PlgContentSocial2s::$s2s_obj->lang = $idioma;
        PlgContentSocial2s::$s2s_obj->lang_twitter = $idioma_twitter;
        PlgContentSocial2s::$s2s_obj->lang_direction = $lang_direction;

        PlgContentSocial2s::updateS2sDebug('LANGUAGE', 'lang: ' . $idioma . ' | twitter: ' . $idioma_twitter . ' | direction: ' . $lang_direction, 'info', 'language');
    }

    /**
     * [STYLES]
     * @return [type] [object]
     */
    public static function getStyles()
    {

        $params = self::$s2s_obj->params;
        $context = self::$s2s_obj->context;

        $art_style_params = self::$s2s_obj->art_style;
        $cat_style_params = self::$s2s_obj->cat_style;

        //ITEM VIEW
        $sign = $art_style_params->get('s2s_font_style', 'icon');
        $style = $art_style_params->get('s2s_style', 'default');
        $align = $art_style_params->get('s2s_button_align', 'left');
        $fill = $art_style_params->get('s2s_fill', '0');
        $group = $art_style_params->get('s2s_group', '1');
        $size = $art_style_params->get('s2s_size', 's2s-btn-default');
        $text = $art_style_params->get('s2s_show_text', 0);
        $balloon = $art_style_params->get('s2s_balloon_pos', '0');

        //CAT VIEW
        if ($context == 'com_content.category' ||
            $context == 'com_content.featured') {
            if (!$params->get('s2s_takefromarticle')) {
                $sign = $cat_style_params->get('s2s_font_style', 'icon');
                $style = $cat_style_params->get('s2s_style', 'default');
                $align = $cat_style_params->get('s2s_button_align', 'left');
                $fill = $cat_style_params->get('s2s_fill', '0');
                $group = $cat_style_params->get('s2s_group', 0);
                $size = $cat_style_params->get('s2s_size', 's2s-btn-default');
                $text = $cat_style_params->get('s2s_show_text', 0);
                $balloon = $cat_style_params->get('s2s_balloon_pos', '0');
            }
        }

        $s2s_group = ($group == '0') ? 's2s-btn-split' : 's2s-btn-group';

        //default
        $image_pixels = '24px';

        if ($size == 's2s-btn-xs') {
            $image_pixels = '16px';
        } elseif ($size == 's2s-btn-sm') {
            $image_pixels = '20px';
        } elseif ($size == 's2s-btn-default') {
            $image_pixels = '24px';
        } elseif ($size == 's2s-btn-lg') {
            $image_pixels = '32px';
        }

        $styles = (object) [
            'style' => $style,
            'align' => $align,
            'fill' => $fill,
            'group' => $s2s_group,
            'size' => $size,
            'image_size' => $image_pixels,
            'sign' => $sign,
            'text' => $text,
            'balloon' => $balloon,
        ];

        return $styles;
    }

    /**
     * [TEMPLATE]
     * @return none
     */
    public static function loadStyle()
    {
        $params = self::$s2s_obj->params;
        $document = Factory::getDocument();
        $plugin_path = self::$s2s_obj->plugin_path;
        $media_path = self::$s2s_obj->media_path;

        $load_base = $params->get('social2s_load_base', true);
        $base = $params->get('social2s_base', '0');
        $minify = $params->get('social2s_minify_debug', 0);
        $load_style = $params->get('s2s_load_style', 1);
        $s2s_button_style = $params->get('s2s_button_style', 'fa');

        $wa = $document->getWebAssetManager();

        $s2s_defer_css = $params->get('social2s_css_defer', 1);

        $tmpl = '';

        $basecss = "";

        $basecss = "s2sdefault";
        if ($base == "1") {
            $basecss = "s2smodern";
        }
        self::$s2s_obj->behavior = $basecss;

        $randomNumber = ($params->get('s2s_debug', 0) == 0) ? md5('5.0.33') : md5(rand(1, 100));



        //LOAD BASE
        if ($load_base && self::$s2s_obj->s2scss_file_loaded == false) {
            if ($s2s_defer_css) {
                $css_path = $media_path . '/css/behavior/s2sdefault.css';

                

                $tmpl .= '<noscript id="deferred-styles_s2s_basecss">
                        <link rel="stylesheet" type="text/css" href="' . $css_path . '"/>
                    </noscript>';
                
                $wa->addInlineScript('
                    const deferredStyles = document.createElement(\'noscript\');
                    deferredStyles.id = \'deferred-styles_s2s_basecss\';
                    
                    const linkElement = document.createElement(\'link\');
                    linkElement.rel = \'stylesheet\';
                    linkElement.type = \'text/css\';
                    linkElement.href = \''.$css_path.'\';
                    deferredStyles.appendChild(linkElement);
                
                document.addEventListener(\'DOMContentLoaded\', function() {
                    document.body.appendChild(deferredStyles);
                        var loadDeferredStyles_s2s_basecss = function() {
                        var addStylesNode = document.getElementById("deferred-styles_s2s_basecss");
                        var replacement = document.createElement("div");
                        replacement.innerHTML = addStylesNode.textContent;
                        document.body.appendChild(replacement)
                        addStylesNode.parentElement.removeChild(addStylesNode);
                        };
                        var raf = requestAnimationFrame || mozRequestAnimationFrame ||
                            webkitRequestAnimationFrame || msRequestAnimationFrame;
                        if (raf) raf(function() { window.setTimeout(loadDeferredStyles_s2s_basecss,50); });
                        else window.addEventListener(\'load\', loadDeferredStyles_s2s_basecss);
                    });
                        ');
                
                PlgContentSocial2s::updateS2sDebug('MINIFY base CSS', 'DEFERRED: ' . $basecss . '.css', 'info', 'file-archive-o');
            } else {
                $wa->registerAndUseStyle(
                    'social2s_base_css',
                    'media/plg_content_social2s/css/behavior/s2sdefault.css',
                    ['version' => $randomNumber,
                        'media' => 'print', 'rel' => 'lazy-stylesheet',
                        'onload' => 'this.media=\'all\'']
                );
            }
        }

        //Style file
        if ($load_style && self::$s2s_obj->s2scss_file_loaded == false) {
            if ($s2s_defer_css) {
                $css_path = $media_path . '/css/styles/' . PlgContentSocial2s::$s2s_obj->styles->style . '.css';

                $tmpl .= '<noscript id="deferred-styles_s2s_style">
                        <link rel="stylesheet" type="text/css" href="' . $css_path . '"/>
                    </noscript>';

                $wa->addInlineScript('
                    const deferredstyles_s2s_style = document.createElement(\'noscript\');
                    deferredstyles_s2s_style.id = \'deferred_styles_s2s_style\';
                    
                    const linkElement_style = document.createElement(\'link\');
                    linkElement_style.rel = \'stylesheet\';
                    linkElement_style.type = \'text/css\';
                    linkElement_style.href = \''.$css_path.'\';
  
                    document.addEventListener(\'DOMContentLoaded\', function() {
                        document.body.appendChild(deferredstyles_s2s_style);
                        var loadDeferredStyles_s2s_style = function() {
                        var addStylesNode = document.getElementById("deferred_styles_s2s_style");
                        var replacement = document.createElement("div");
                        replacement.innerHTML = addStylesNode.textContent;
                        document.body.appendChild(replacement)
                        addStylesNode.parentElement.removeChild(addStylesNode);
                        };
                        var raf = requestAnimationFrame || mozRequestAnimationFrame ||
                            webkitRequestAnimationFrame || msRequestAnimationFrame;
                        if (raf) raf(function() { window.setTimeout(loadDeferredStyles_s2s_style, 100); });
                        else window.addEventListener(\'load\', loadDeferredStyles_s2s_style);
                    });
                    ');

                PlgContentSocial2s::updateS2sDebug('LOAD STYLE CSS', 'DEFERRED: ' . $media_path . '/css/styles/' . PlgContentSocial2s::$s2s_obj->styles->style . '.css', 'success', 'css3');
            } else {
                $wa->registerAndUseStyle(
                    'social2s_style_css',
                    'media/plg_content_social2s/css/styles/' . PlgContentSocial2s::$s2s_obj->styles->style . '.css',
                    ['version' => $randomNumber, 'media' => 'print', 'rel' => 'lazy-stylesheet',
                        'onload' => 'this.media=\'all\'']
                );
            }
        }

        self::$s2s_obj->s2scss_file_loaded = true;

        return $tmpl;
    }

    /**
     * [BUTTONS]
     * @return [type] [array]
     */
    public static function getButtons()
    {
        $context = self::$s2s_obj->context;
        $params = self::$s2s_obj->params;
        $styles = PlgContentSocial2s::$s2s_obj->styles;

        //paths
        $images_path = self::$s2s_obj->images_path;
        $media_path = self::$s2s_obj->media_path;

        //font style
        $font_style = $styles->sign;
        if ($styles->sign == '0') {
            $font_style = '';
        }

        $texts = self::getTexts($styles->text);

        $buttons = array();

        $s2s_button_style = $params->get('s2s_icon_image', 'fa');


        if ($s2s_button_style == '1') {
            $buttons['twitter'] = '<i class="s2sfo fo-twitter' . $font_style . '"></i>  ' . $texts['twitter'];
            $buttons['facebook'] = '<i class="s2sfo fo-facebook' . $font_style . '"></i>  ' . $texts['facebook'];
            $buttons['pinterest'] = '<i class="s2sfo fo-pinterest' . $font_style . '"></i>  ' . $texts['pinterest'];
            $buttons['linkedin'] = '<i class="s2sfo fo-linkedin' . $font_style . '"></i>  ' . $texts['linkedin'];
            $buttons['gplus'] = '<i class="s2sfo fo-google-plus' . $font_style . '"></i>  ' . $texts['gplus'];
            $buttons['wapp'] = '<i class="s2sfo fo-whatsapp' . $font_style . '"></i>  ' . $texts['wapp'];
            $buttons['tgram'] = '<i class="s2sfo fo-tgram' . $font_style . '"></i>  ' . $texts['tgram'];
            $buttons['flipb'] = '<i class="s2sfo fo-flipb' . $font_style . '"></i>  ' . $texts['flipb'];
            $buttons['vk'] = '<i class="s2sfo fo-vk' . $font_style . '"></i>  ' . $texts['vk'];
            $buttons['delio'] = '<i class="s2sfo fo-delio' . $font_style . '"></i>  ' . $texts['delio'];
            $buttons['snap'] = '<i class="fab fa-snapchat' . $font_style . '"></i>  ' . $texts['snap'];
            $buttons['tumblr'] = '<i class="s2sfo fo-tumblr' . $font_style . '"></i>  ' . $texts['tumblr'];
            $buttons['reddit'] = '<i class="s2sfo fo-reddit' . $font_style . '"></i>  ' . $texts['reddit'];
            $buttons['email'] = '<i class="s2sfo fo-email' . $font_style . '"></i>  ' . $texts['email'];

            //FONTAWESOME
        } elseif ($s2s_button_style == 'fa') {
            $buttons['twitter'] = '<i class="fab fa-x-twitter" title="Twitter"></i>  ' . $texts['twitter'];
            $buttons['facebook'] = '<i class="fab fa-facebook" title="Facebook"></i>  ' . $texts['facebook'];
            $buttons['pinterest'] = '<i class="fab fa-pinterest" title="Pinterest"></i>  ' . $texts['pinterest'];
            $buttons['linkedin'] = '<i class="fab fa-linkedin" title="Linkedin"></i>  ' . $texts['linkedin'];
            $buttons['gplus'] = '<i class="fab fa-google-plus"></i>  ' . $texts['gplus'];
            $buttons['wapp'] = '<i class="fab fa-whatsapp" title="Whatsapp"></i>  ' . $texts['wapp'];
            $buttons['tgram'] = '<i class="fab fa-telegram" title="Telegram"></i>  ' . $texts['tgram'];
            $buttons['flipb'] = '<i class="fab fa-flipboard" title="Flipboard"></i>  ' . $texts['flipb'];
            $buttons['vk'] = '<i class="fab fa-vk" title="vk"></i>  ' . $texts['vk'];
            $buttons['delio'] = '<i class="fab fa-delicious" title="Delicious"></i>  ' . $texts['delio'];
            $buttons['snap'] = '<i class="fab fa-snapchat" title="Snapchat"></i>  ' . $texts['snap'];
            $buttons['tumblr'] = '<i class="fab fa-tumblr" title="Tumblr"></i>  ' . $texts['tumblr'];
            $buttons['reddit'] = '<i class="fab fa-reddit" title="Teddit"></i>  ' . $texts['reddit'];
            $buttons['email'] = '<i class="fas fa-envelope" title="Email"></i>  ' . $texts['email'];

            //IMAGES
        } elseif ($s2s_button_style == 'image') {
            $image_pixels = $styles->image_size;

            $images_path = $images_path . 'svg/' . $styles->sign . '/';

            $buttons['twitter'] = '<img src="' . $images_path . 'x-twitter.svg" alt="twitter button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['twitter'];
            $buttons['facebook'] = '<img src="' . $images_path . 'facebook.svg" alt="facebook button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['facebook'];
            $buttons['pinterest'] = '<img src="' . $images_path . 'pinterest.svg" alt="pinterest button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['pinterest'];
            $buttons['linkedin'] = '<img src="' . $images_path . 'linkedin.svg" alt="linkedin button"  width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['linkedin'];
            $buttons['gplus'] = '<img src="' . $images_path . 'gplus.svg" alt="gplus button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['gplus'];
            $buttons['wapp'] = '<img src="' . $images_path . 'whatsapp.svg" alt="whatsapp button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['wapp'];
            $buttons['tgram'] = '<img src="' . $images_path . 'telegram.svg" alt="telegram button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['tgram'];
            $buttons['flipb'] = '<img src="' . $images_path . 'flipboard.svg" alt="flipboard button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['flipb'];
            $buttons['delio'] = '<img src="' . $images_path . 'delio.svg" alt="delicious button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['delio'];
            $buttons['snap'] = '<img src="' . $images_path . 'snapchat.svg" alt="snapchat button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['snap'];
            $buttons['tumblr'] = '<img src="' . $images_path . 'tumblr.svg" alt="tumblr button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['tumblr'];
            $buttons['reddit'] = '<img src="' . $images_path . 'reddit.svg" alt="tumblr button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['reddit'];
            $buttons['vk'] = '<img src="' . $images_path . 'vk.svg" alt="vk button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['vk'];
            $buttons['email'] = '<img src="' . $images_path . 'email.svg" alt="email button" width="' . $image_pixels . '" height="' . $image_pixels . '"/>' . $texts['email'];
        } else {
            //default
            $buttons['twitter'] = $texts['twitter'];
            $buttons['facebook'] = $texts['facebook'];
            $buttons['pinterest'] = $texts['pinterest'];
            $buttons['linkedin'] = $texts['linkedin'];
            $buttons['gplus'] = $texts['gplus'];
            $buttons['wapp'] = $texts['wapp'];
            $buttons['tgram'] = $texts['tgram'];
            $buttons['flipb'] = $texts['flipb'];
            $buttons['delio'] = $texts['delio'];
            $buttons['snap'] = $texts['snap'];
            $buttons['tumblr'] = $texts['tumblr'];
            $buttons['reddit'] = $texts['reddit'];
            $buttons['vk'] = $texts['vk'];
            $buttons['email'] = $texts['email'];
        }

        return $buttons;
    }

    /**
     * [BUTTONS - TEXT]
     * @param  [type] $show_text [BOOL]
     * @return [type]            [ARRAY]
     */
    public static function getTexts($show_text)
    {
        $texts = array();
        if ($show_text) {
            $texts['twitter'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_TWITTER') . '</span>';
            $texts['facebook'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_FACEBOOK') . '</span>';
            $texts['pinterest'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_PINTEREST') . '</span>';
            $texts['linkedin'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_LINKEDIN') . '</span>';
            $texts['gplus'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_GPLUS') . '</span>';
            $texts['wapp'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_WAPP') . '</span>';
            $texts['tgram'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_TGRAM') . '</span>';
            $texts['flipb'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_FLIPB') . '</span>';
            $texts['delio'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_DELIO') . '</span>';
            $texts['snap'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_SNAP') . '</span>';
            $texts['tumblr'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_TUMBLR') . '</span>';
            $texts['reddit'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_REDDIT') . '</span>';
            $texts['vk'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_VK') . '</span>';
            $texts['email'] = '<span class="s2s_social_text">' . Text::_('SOCIAL2S_EMAIL') . '</span>';
        } else {
            $texts['twitter'] = "";
            $texts['facebook'] = "";
            $texts['pinterest'] = "";
            $texts['linkedin'] = "";
            $texts['gplus'] = "";
            $texts['wapp'] = "";
            $texts['tgram'] = "";
            $texts['flipb'] = "";
            $texts['delio'] = "";
            $texts['snap'] = "";
            $texts['tumblr'] = "";
            $texts['reddit'] = "";
            $texts['vk'] = "";
            $texts['email'] = "";
        }
        return $texts;
    }

    /**
     * [VARIABLES inject variables in js]
     * @return [type] NONE
     */
    public static function getVariables()
    {
        $params = self::$s2s_obj->params;
        $jsparams = array();

        $doc = Factory::getDocument();

        // Most likely need this later
        //$doc = PlgContentSocial2s::getDoc();

        $wa = $doc->getWebAssetManager();

        //injection
        $insert = $params->get('s2s_insert', '0');
        $insert_position = $params->get('s2s_insert_position', '0');
        $insert_element = $params->get('s2s_insert_element', '');

        //cookies
        $checkCookie = $params->get('s2s_stupid_cookie_on', '0');

        //language
        $s2s_lang_1tag = self::$s2s_obj->lang;
        $s2s_lang_2tag = self::$s2s_obj->lang_twitter;
        $s2s_lang_direction = self::$s2s_obj->lang_direction;

        //general
        $s2s_load_scripts_onload = $params->get('s2s_load_scripts_onload', '0');
        $s2s_context = self::$s2s_obj->context;
        $s2s_debug = $params->get('s2s_debug', 0);
        $s2s_version = self::_getVersion();

        //pos fixed
        $s2s_art_mobile_min = $params->get('s2s_art_mobile_min', 978);

        //license
        $s2s_sha = $params->get('s2s_license_email', '');

        //CTA
        $s2s_cta_active = $params->get('s2s_cta_active', 0);
        if (self::$s2s_obj->context != 'com_content.article') {
            $s2s_cta_active = 0;
        }

        $s2s_cta_default = $params->get('s2s_cta_default', 'twitter');

        //DATA
        $safefull_link = rawurlencode(self::$s2s_obj->full_link);

        $safetitle = rawurlencode(self::$s2s_obj->title);

        $jsparams['s2s_checkCookie'] = $checkCookie;
        $jsparams['s2s_lang_1tag'] = $s2s_lang_1tag;
        $jsparams['s2s_load_scripts_onload'] = $s2s_load_scripts_onload;

        $jsparams['s2s_cta_active'] = $s2s_cta_active;
        $jsparams['s2s_cta_default'] = $s2s_cta_default;

        $jsparams['php_full_link'] = $safefull_link;
        $jsparams['php_title'] = $safetitle;

        //DEPRECATED
        $jsparams['s2s_context'] = $s2s_context;
        $jsparams['s2s_lang_2tag'] = $s2s_lang_2tag;
        $jsparams['insert'] = $insert;
        $jsparams['insert_position'] = $insert_position;
        $jsparams['insert_element'] = $insert_element;
        $jsparams['s2s_lang_direction'] = $s2s_lang_direction;
        $jsparams['s2s_debug'] = $s2s_debug;
        $jsparams['s2s_version'] = $s2s_version;
        $jsparams['s2s_art_mobile_min'] = $s2s_art_mobile_min;
        $jsparams['s2s_sha'] = $s2s_sha;

        $jsparamsjson = json_encode($jsparams);

        $wa->addInlineScript('var s2s_params = ' . $jsparamsjson . ';', [], ['type' => 'text/javascript']);
    }

    /**
     * [_getVersion gets the plugin version]
     * @return [type] [string]
     */
    private static function _getVersion()
    {
        $db = Factory::getContainer()->get('DatabaseDriver');
        $query = $db->getQuery(true);
        $query
            ->select(array('*'))
            ->from($db->quoteName('#__extensions'))
            ->where($db->quoteName('type') . ' = ' . $db->quote('plugin'))
            ->where($db->quoteName('element') . ' = ' . $db->quote('social2s'))
            ->where($db->quoteName('folder') . ' = ' . $db->quote('content'));
        $db->setQuery($query);
        $result = $db->loadObject();
        $manifest_cache = json_decode($result->manifest_cache);
        if (isset($manifest_cache->version)) {
            return $manifest_cache->version;
        }
        return;
    }

    /**
     * [getCookieButton]
     * @return [type] [html]
     */
    public static function getCookieButton()
    {
        return;
    }

    /**
     * [checkcookiecomponents]
     * @return [type] [bool]
     */
    private static function checkcookiecomponents()
    {
        //no cookies anymore
        return false;
    }

    /**
     * [getSupraClasses classes for supracontenedor]
     * @return [type] [array]
     */
    public static function getSupraClasses()
    {
        $params = self::$s2s_obj->params;
        $context = self::$s2s_obj->context;

        $s2s_button_img_fa = $params->get('s2s_button_style', 'fa');

        //COOKIES
        $checkCookie = $params->get('s2s_stupid_cookie_on', '0');
        $cookieclass = ($checkCookie ? "cookie_on" : "");
        if (self::$s2s_obj->cookie_button == "") {
            $cookieclass = "";
        }

        //BTN class
        $btn_group_class = 's2s-btn-group';

        //POSITION FIXED
        //review 4.0 TODO
        $s2s_pos_fix = $params->get('s2s_art_fixed', 0);
        $pos_fix = '';

        if ($s2s_pos_fix && $context == 'com_content.article') {
            $s2s_art_fixed_mode = $params->get('s2s_art_fixed_mode', 's2s_fixed_horizontal');
            $s2s_art_fixed_posx = $params->get('s2s_art_fixed_posx', 'right');
            $s2s_art_fixed_posy = $params->get('s2s_art_fixed_posy', 'center');

            $pos_fix .= ' s2s_pos_fixed ';
            $pos_fix .= $s2s_art_fixed_mode;
            $pos_fix .= ' s2s_pos_fix_x_' . $s2s_art_fixed_posx;
            $pos_fix .= ' s2s_pos_fix_y_' . $s2s_art_fixed_posy;

            //btn class
            if ($s2s_art_fixed_mode == "s2s_fixed_vertical") {
                $btn_group_class = 's2s-btn-group-vertical';
            }
        }

        //BALLOON POSITION
        $s2s_art_balloon_pos = $params->get('s2s_art_balloon_pos', '0');

        if ($s2s_art_balloon_pos) {
            $balloon_pos = 's2s_balloon_top';
        } else {
            $balloon_pos = 's2s_balloon_bottom';
        }

        //FILL
        $s2s_art_fill = $params->get('s2s_art_fill', '0');
        $s2s_cat_fill = $params->get('s2s_cat_fill', '0');
        if ($params->get('s2s_takefromarticle', '1')) {
            $s2s_cat_fill = $s2s_art_fill;
        }

        //TEXT_CLASS
        $s2s_art_text = $params->get('s2s_art_show_text', '0');
        $s2s_cat_text = $params->get('s2s_cat_show_text', '0');
        if ($params->get('s2s_takefromarticle', '1')) {
            $s2s_cat_text = $s2s_art_text;
        }

        //STICKY_CLASS
        $s2s_art_sticky = $params->get('s2s_art_sticky', '0');
        $s2s_cat_sticky = $params->get('s2s_art_sticky', '0');
        if ($params->get('s2s_takefromarticle', '1')) {
            $s2s_cat_sticky = $s2s_art_sticky;
        }

        //check article
        if ($context == 'com_content.article') {
            //fill
            if ($s2s_art_fill == 0) {
                $css_fill = '';
            } elseif ($s2s_art_fill == 1) {
                $css_fill = 's2s_fill';
            } else {
                $css_fill = 's2s_fill_mobile';
            }
            //text class
            if ($s2s_art_text == 0) {
                $css_text = 's2s_no_text';
            } elseif ($s2s_art_text == 1) {
                $css_text = 's2s_text';
            } else {
                $css_text = 's2s_text_mobile';
            }
            //sticky class
            if ($s2s_art_sticky == 0) {
                $css_sticky = '';
            } elseif ($s2s_art_sticky == 1) {
                $css_sticky = 's2s_sticky';
            } else {
                $css_sticky = 's2s_sticky_mobile';
            }

            //check category
        } elseif ($context == 'com_k2.itemlist'
            || $context == 'com_content.category'
            || $context == 'com_content.featured') {
            //fill
            if ($s2s_cat_fill == 0) {
                $css_fill = '';
            } elseif ($s2s_cat_fill == 1) {
                $css_fill = 's2s_fill';
            } else {
                $css_fill = 's2s_fill_mobile';
            }

            //css text
            if ($s2s_cat_text == 0) {
                $css_text = 's2s_no_text';
            } elseif ($s2s_cat_text == 1) {
                $css_text = 's2s_text';
            } else {
                $css_text = 's2s_text_mobile';
            }

            //sticky class
            if ($s2s_cat_sticky == 0) {
                $css_sticky = '';
            } elseif ($s2s_cat_sticky == 1) {
                $css_sticky = 's2s_sticky';
            } else {
                $css_sticky = 's2s_sticky_mobile';
            }

            //check category
        } else {
            //fill
            if ($s2s_cat_fill == 0) {
                $css_fill = '';
            } elseif ($s2s_cat_fill == 1) {
                $css_fill = 's2s_fill';
            } else {
                $css_fill = 's2s_fill_mobile';
            }

            //css text
            if ($s2s_cat_text == 0) {
                $css_text = 's2s_no_text';
            } elseif ($s2s_cat_text == 1) {
                $css_text = 's2s_text';
            } else {
                $css_text = 's2s_text_mobile';
            }

            //sticky class
            if ($s2s_cat_sticky == 0) {
                $css_sticky = '';
            } elseif ($s2s_cat_sticky == 1) {
                $css_sticky = 's2s_sticky';
            } else {
                $css_sticky = 's2s_sticky_mobile';
            }
        }

        $classes = array(
            'lang_direction' => self::$s2s_obj->lang_direction,
            'behavior' => self::$s2s_obj->behavior,
            'cookieclass' => $cookieclass,
            'align' => 'align_' . PlgContentSocial2s::$s2s_obj->styles->align,
            'pos_fix' => $pos_fix,
            'balloon_pos' => $balloon_pos,
            'css_fill' => $css_fill,
            'css_text' => $css_text,
            's2s_sticky' => $css_sticky,
            'btn_group_class' => PlgContentSocial2s::$s2s_obj->styles->group,
            's2s_button_' . $s2s_button_img_fa,
        );

        PlgContentSocial2s::updateS2sDebug('Classes', implode(' | ', $classes), 'info', 'cog');

        return (object) $classes;
    }

    /**
     * [ORDER && SOCIAL]
     * @return [type] [array]
     */
    public static function getSocial()
    {
        $params = self::$s2s_obj->params;

        //get order
        $s2s_order = explode(',', $params->get('s2s_order', '0,1,2,3,4,5,6,7,8,9,10,11,12,13'));

        //elimino el último valor porque esta vacío
        //array_pop($s2s_order);

        //check number (12 elements currently)
        if (count($s2s_order) != 14) {
            $s2s_order = explode(',', '0,1,2,3,4,5,6,7,8,9,10,11,12,13');
        }

        require_once 'social.php';
        $s2s_social = new S2sSocial;

        $afterplus = '';
        $param_mas_on = $params->get('mas_on', 0);
        $mas_on = false;

        if ($param_mas_on) {
            $mas_on = true;
            if ($param_mas_on == 2) {
                if (!self::$s2s_obj->jmobile) {
                    $mas_on = false;
                }
            }
        }

        //check if it is last
        if (end($s2s_order) == '13') {
            $mas_on = false;
        }

        $html = '';
        foreach ($s2s_order as $key => $value) {
            if (!$mas_on) {
                $afterplus = '';
            }

            if ($value == '0') {
                //TWITTER
                if ($params->get('twitter_on', 1)) {
                    // new
                    $html .= $s2s_social->getTwitterOwn($afterplus);

                    //legacy
                    //$html .= $s2s_social->getTwitter($afterplus);
                }
            } elseif ($value == '1') {
                //FACEBOOK
                if ($params->get('facebook_on', 1)) {
                    $html .= $s2s_social->getFacebook($afterplus);
                }
            } elseif ($value == '2') {
                //PINTEREST
                if ($params->get('pinterest_on', 1)) {
                    $html .= $s2s_social->getPinterest($afterplus);
                }
            } elseif ($value == '3') {
                //LINKEDIN
                if ($params->get('linkedin_on', 1)) {
                    $html .= $s2s_social->getLinkedin($afterplus);
                }
            } elseif ($value == '5') {
                //WAPP
                if ($params->get('wapp_on', 0)) {
                    $html .= $s2s_social->getWapp($afterplus);
                }
            } elseif ($value == '6') {
                //TGRAM
                if ($params->get('tgram_on', 0)) {
                    $html .= $s2s_social->getTgram($afterplus);
                }
            } elseif ($value == '7') {
                //FLIPB
                if ($params->get('flipb_on', 0)) {
                    $html .= $s2s_social->getFlipb($afterplus);
                }
            } elseif ($value == '8') {
                //SNAPCHAT
                if ($params->get('snap_on', 0)) {
                    $html .= $s2s_social->getSnap($afterplus);
                }
            } elseif ($value == '9') {
                //TUMBLR
                if ($params->get('tumblr_on', 1)) {
                    $html .= $s2s_social->getTumblr($afterplus);
                }
            } elseif ($value == '10') {
                //vk
                if ($params->get('vk_on', 0)) {
                    $html .= $s2s_social->getVk($afterplus);
                }
            } elseif ($value == '11') {
                //email
                if ($params->get('email_on', 0)) {
                    $html .= $s2s_social->getEmail($afterplus);
                }
            } elseif ($value == '12') {
                //email
                if ($params->get('reddit_on', 0)) {
                    $html .= $s2s_social->getReddit($afterplus);
                }
            } elseif ($value == '13') {
                //MORE
                $afterplus = 'afterplus';
                if ($params->get('mas_on', 0)) {
                    //$html .= $s2s_social->getMas($params, $button_size, $buttons, $cookie_button, $title, $full_link, $idioma_twitter, $idioma, $texts, $context, $article);
                }
            }
        }

        //boton +
        if ($mas_on) {
            $html .= $s2s_social->getMas();
        }

        return $html;
    }
}
