<?php

/**
 * @package     Joomla.Plugin
 * @subpackage  Content.vote
 *
 * @copyright   (C) 2016 Open Source Matters, Inc. <https://www.joomla.org>
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Jtotal\Plugin\Content\Social2s\Helper\S2sTmpl;

/**
 * Layout variables
 * -----------------
 * @var   string   $context  The context of the content being passed to the plugin
 * @var   object   &$s2s_obj The s2s object
 * @var   object   &$params  The S2s object params
 * @var   string   $path     Path to this file
 */

$social = S2sTmpl::getSocial();
$class = S2sTmpl::$s2s_obj->supraclasses;

$noscripts = S2sTmpl::$s2s_noscripts;


$html = '';

$html .= $noscripts;

$html .= '<div class="s2s_supra_contenedor ' . $class->lang_direction . ' ' . $class->behavior . ' ' . $class->cookieclass . ' ' . $class->align . ' ' . $class->pos_fix . ' ' . $class->balloon_pos . ' ' . $class->s2s_sticky . '" >';

$uri = uri::getInstance();
$absolute_url = $uri->toString();
//4.0.138
//$s2s_current_url = $absolute_url;
$s2s_current_url = self::$s2s_obj->full_link;
$html .= '<input name="social2s_url" type="hidden" class="social2s_url" value="' . $s2s_current_url . '" />';

//SHARE TEXT
$s2s_share_text = Text::_($params->get('s2s_text_to_share_text', 'SOCIAL2S_SHARE_TEXT'));

//share text top
if ($params->get('s2s_text_to_share', 0) && $params->get('s2s_text_to_share_position', 0) == 0) {
    $html .= '<span class="s2s_share_text s2s_share_text_top">' . $s2s_share_text . '</span><div class="clearfix"></div>';
}

$html .= '<div class="s2s_contenedor ' . $class->css_fill . ' ' . $class->css_text . ' ' . $class->btn_group_class . '">';

//share text left
if ($params->get('s2s_text_to_share', 0) && $params->get('s2s_text_to_share_position', 0) == 1) {
    $html .= '<span class="s2s_share_text s2s_share_text_left">' . $s2s_share_text . '</span>';
}

//botones
$html .= $social;

/*cierro contenedor*/
$html .= '</div>';

//CREDITS
if ($params->get('s2s_credits', 1)) {
    $html .= '<div class="s2s_credits_wrapper"><small class="social2s_credits clearfix small">powered by <a rel="nofollow" target="_blank" href="https://jtotal.org/joomla/plugins/social2s">social2s</a></small></div>';
}

/*cierro supra contenedor*/
$html .= '</div>';

return $html;
